import os
import sys
from bson import json_util
current_dir = os.path.dirname(__file__)
parent_dir = os.path.abspath(os.path.join(current_dir, '..'))
sys.path.append(parent_dir)
import json


# get_markers requests all marker data from mongoDB
def get_all_markers(self, cursor):
    try:

        # Fetch all data
        cursor.execute('''
            SELECT m.MeasurementID, m.SensorID, m.TimeMeasured, m.Latitude, m.Longitude,
                   m.MeasuredThickness, m.Accuracy, s.SensorType, s.Active
            FROM Measurement m
            INNER JOIN Sensor s ON m.SensorID = s.SensorID
        ''')

        rows = cursor.fetchall()

        data = []
        for row in rows:
            measurement = {
                'MeasurementID': row[0],
                'TimeMeasured': row[1],
                'Latitude': row[2],
                'Longitude': row[3],
                'MeasuredThickness': row[4],
                'Accuracy': row[5],
                'Sensor': {
                    'SensorID': row[6],
                    'SensorType': row[7],
                    'Active': bool(row[8])
                }
            }
            data.append(measurement)

        resp_code = 200
        # Convert the list of dictionaries to JSON
        marker_json = json.dumps(data, indent=4)

    except Exception as e:
        print(f"An error occurred while querying MongoDB: {e}")
        resp_code = 500
        marker_json = '[]'

    # Set headers
    self.send_response(resp_code)
    self.send_header("Content-type", "application/json")
    self.end_headers()

    # Write marker_data to the response object
    self.wfile.write(marker_json.encode('utf-8'))
